<?php
namespace Modules\Cadastros\Controllers; 

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification;

class ProdutoApenasConsumoController extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $dataSourceName = 'prodnececomp_produto';
    
    public function __construct($crudService, ParameterBag $parameterBag, $connection) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->con = $connection;
    }
    
    public function save(DTO\Request $request, DTO\Response $response) {
		$data = $request->getDataSet()->getRows();
		
		$query = 'SELECT * FROM PRODNECECOMP WHERE CDFILIAL=:CDFILIAL AND CDPRODUTO=:CDPRODUTO';
		$stmt = $this->con->prepare($query);
		$stmt->execute(array(
		    "CDFILIAL" => $data[0]['CDFILIAL'],
		    "CDPRODUTO" => $data[0]['CDPRODUTO']
		));
		
		$a = $stmt->fetchAll();
		
		try{
        	if(sizeof($a) == 0) {
        	
        		$query = 'INSERT INTO PRODNECECOMP (CDFILIAL, CDPRODUTO) VALUES (:CDFILIAL, :CDPRODUTO)';
        		$stmt = $this->con->prepare($query);
        		$stmt->execute(array(
        		    "CDFILIAL" => $data[0]['CDFILIAL'],
        		    "CDPRODUTO" => $data[0]['CDPRODUTO']
        		));
        	}
		} catch (\Exception $e) {
				$response->setError(new Error($e->getMessage(), 500));
		}
    }
    
    public function deleteProd(DTO\Request $request, DTO\Response $response) {
    	
    	$data = $request->getDataSet()->getRows();
    	
    	$query = 'DELETE FROM PRODNECECOMP WHERE CDFILIAL = :CDFILIAL AND (INSTR((SELECT PRODUTO.CDARVPROD FROM PRODUTO WHERE PRODUTO.CDPRODUTO = PRODNECECOMP.CDPRODUTO), :CDPRODUTO) = 1) AND ((SELECT P.CDARVPROD FROM PRODUTO P WHERE P.CDPRODUTO = PRODNECECOMP.CDPRODUTO) > :CDPRODUTO)';
		$stmt = $this->con->prepare($query);
		$stmt->execute(array(
		    "CDFILIAL" => $data[0]['CDFILIAL'],
		    "CDPRODUTO" => $data[0]['CDPRODUTO']
		));
    }
}