IF EXISTS (SELECT *
             FROM SYSOBJECTS O, SYSUSERS U
            WHERE O.NAME = 'DMS_LONDRINA'
    	      AND TYPE   = 'P'
	      AND U.UID  = O.UID
	      AND U.NAME = USER)
DROP PROCEDURE DMS_LONDRINA
GO

CREATE PROCEDURE DMS_LONDRINA
   @P_NRLISTA       VARCHAR(10),
   @P_CDEMPRESA     VARCHAR(02),
   @P_NRSEQARQMAG   VARCHAR(10),
   @P_LIVROMAG      VARCHAR(10),
   @P_TIPOSERVICO   VARCHAR(01)
AS
   DECLARE  @V_CONTADOR    DOUBLE PRECISION;

   DECLARE  @C_DADOS       VARCHAR(150);
   DECLARE  @C_NRLANCTONF  VARCHAR(10);
   DECLARE  @C_CDFILIAL    VARCHAR(04);


BEGIN
   SET @V_CONTADOR = 0;
   /*Servios Prestados - Notas de Sada*/
   IF @P_TIPOSERVICO = 'P' BEGIN
      DECLARE C_PREST CURSOR FOR (
         SELECT NF.CDINSCMUNI      +';'+ /*Inscrio Municipal do Prestador*/
                NF.NRNOTAFISC      +';'+ /*Nmero da Nota Inicial*/
                NF.NRNOTAFISC      +';'+ /*Nmero da Nota Final*/
                ISNULL(NF.CDSERIE,'') +';'+ /*Srie*/
                ''                 +';'+ /*Sub-Srie*/
                CONVERT(VARCHAR,DAY(NF.DTEMISSAO)) +';'+ /*Dia de Emissao*/
                CD.CDEXPDECLISS    +';'+ /*Cdigo do Servio*/
                'tp'               +';'+ /*Tomador (Situao da Nota)*/
                LTRIM(REPLACE(CONVERT(VARCHAR,CAST(ROUND(NF.VRNOTAFISC,2) AS MONEY)), '.', ','))        +';'+ /*Valor da Nota*/
                LTRIM(REPLACE(CONVERT(VARCHAR,CAST(SUM(ROUND(IT.VRBASECALCIT,2)) AS MONEY)), '.', ',')) +';'+ /*Valor do Servio*/
                ISNULL(CASE NF.IDORIGDESTNF WHEN 'F' THEN FO.NRINSJURFORN WHEN 'C' THEN CL.NRINSJURCLIE ELSE FI.NRINSJURFILI END,'') +';'+ /*CNPJ do Tomador*/
                'T'          AS DADOS_P, /*Talo*/
                NF.NRLANCTONF, NF.CDFILIAL
           FROM LISTA LS, ITEMPRODUTO IP, ITEMPROIMPOS IT, CODEXPDECLISS CD, TPIMPOSLIVRO TI,
                NOTAFISCAL NF LEFT JOIN FILIAL FI     ON (NF.CDFILIRECE = FI.CDFILIAL  )
                              LEFT JOIN FORNECEDOR FO ON (NF.CDFORNECED = FO.CDFORNECED)
                              LEFT JOIN CLIENTE CL    ON (NF.CDCLIENTE  = CL.CDCLIENTE )
          WHERE LS.NRLISTA      = @P_NRLISTA
            AND LS.CDLISTA      = NF.CDFILIAL+NF.NRLANCTONF
            AND NF.IDENTRSAIDOP = 'S'
            AND IP.NRLANCTONF   = NF.NRLANCTONF
            AND IP.CDFILIAL     = NF.CDFILIAL
            AND IP.CDPRODUTO    = CD.CDPRODUTO
            AND CD.CDEMPRESA    = @P_CDEMPRESA
            AND CD.CDINSCESTA   = NF.CDINSCESTA
            AND CD.CDINSCMUNI   = NF.CDINSCMUNI
            AND IP.CDFILIAL     = IT.CDFILIAL
            AND IP.NRLANCTONF   = IT.NRLANCTONF
            AND IP.NRSEQITPROD  = IT.NRSEQITPROD
            AND IT.CDIMPOSTO    = TI.CDIMPOSTOLIVRO
            AND TI.CDLIVROMAG   = @P_LIVROMAG
          GROUP BY NF.CDINSCMUNI, NF.NRNOTAFISC, NF.CDSERIE, NF.DTEMISSAO, CD.CDEXPDECLISS, NF.VRNOTAFISC,
                   CASE NF.IDORIGDESTNF WHEN 'F' THEN FO.NRINSJURFORN WHEN 'C' THEN CL.NRINSJURCLIE ELSE FI.NRINSJURFILI END,
                   NF.NRLANCTONF, NF.CDFILIAL)
          ORDER BY NF.NRNOTAFISC

      OPEN C_PREST;
      FETCH NEXT FROM C_PREST INTO @C_DADOS, @C_NRLANCTONF, @C_CDFILIAL;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           (@V_CONTADOR, @C_DADOS , @P_NRSEQARQMAG);
         SET @V_CONTADOR = ISNULL(@V_CONTADOR,0)+1;

         UPDATE NOTAFISCAL
            SET IDEXPNFEDMSLON = 'S'
          WHERE CDFILIAL       = @C_CDFILIAL
            AND NRLANCTONF     = @C_NRLANCTONF;

         FETCH NEXT FROM C_PREST INTO @C_DADOS, @C_NRLANCTONF, @C_CDFILIAL;

      END;
      CLOSE C_PREST;
      DEALLOCATE C_PREST;

    /*Servios Tomados - Notas de Entrada*/
   END
   ELSE BEGIN
      DECLARE C_TOMAD CURSOR FOR (
         SELECT ISNULL(CASE NF.IDORIGDESTNF WHEN 'F' THEN FO.NRINSJURFORN WHEN 'C' THEN CL.NRINSJURCLIE ELSE FI.NRINSJURFILI END,'') +';'+ /*CNPJ do Prestador*/
                NF.NRNOTAFISC     +';'+ /*Nmero da Nota*/
                ISNULL(NF.CDSERIEENTR,'')    +';'+ /*Srie*/
                ''                +';'+ /*Sub-Srie*/
                CONVERT(VARCHAR,DAY(NF.DTEMISSAO)) +';'+ /*Dia de Emissao*/
                CD.CDEXPDECLISS   +';'+ /*Cdigo do Servio*/
                'tt'              +';'+ /*Tomador (Situao da Nota)*/
                LTRIM(REPLACE(CONVERT(VARCHAR,CAST(SUM(ROUND(IT.VRBASECALCIT,2)) AS MONEY)), '.', ',')) +';'+  /*Valor do Servio*/
                NF.CDINSCMUNI     +';'+ /*CMC do Tomador*/
                'T'               +';'+ /*Tipo de Nota*/
                ''                +';'+ /*Alquota Simples*/
                'C'          AS DADOS_C, /*Lanamento Concludo*/
                NF.NRLANCTONF, NF.CDFILIAL
           FROM LISTA LS, ITEMPRODUTO IP, ITEMPROIMPOS IT, CODEXPDECLISS CD, TPIMPOSLIVRO TI,
                NOTAFISCAL NF LEFT JOIN FILIAL FI     ON (NF.CDFILIRECE = FI.CDFILIAL  )
                              LEFT JOIN FORNECEDOR FO ON (NF.CDFORNECED = FO.CDFORNECED)
                              LEFT JOIN CLIENTE CL    ON (NF.CDCLIENTE  = CL.CDCLIENTE )
          WHERE LS.NRLISTA       = @P_NRLISTA
            AND LS.CDLISTA       = NF.CDFILIAL+NF.NRLANCTONF
            AND NF.IDENTRSAIDOP  = 'E'
            AND IP.NRLANCTONF    = NF.NRLANCTONF
            AND IP.CDFILIAL      = NF.CDFILIAL
            AND IP.CDPRODUTO     = CD.CDPRODUTO
            AND CD.CDEMPRESA     = @P_CDEMPRESA
            AND CD.CDINSCESTA    = NF.CDINSCESTA
            AND CD.CDINSCMUNI    = NF.CDINSCMUNI
            AND IP.CDFILIAL      = IT.CDFILIAL
            AND IP.NRLANCTONF    = IT.NRLANCTONF
            AND IP.NRSEQITPROD   = IT.NRSEQITPROD
            AND IT.CDIMPOSTO     = TI.CDIMPOSTOLIVRO
            AND TI.CDLIVROMAG    = @P_LIVROMAG
          GROUP BY CASE NF.IDORIGDESTNF WHEN 'F' THEN FO.NRINSJURFORN WHEN 'C' THEN CL.NRINSJURCLIE ELSE FI.NRINSJURFILI END,
                   NF.NRNOTAFISC, NF.CDSERIEENTR, NF.DTEMISSAO, CD.CDEXPDECLISS, NF.CDINSCMUNI,
                   NF.NRLANCTONF, NF.CDFILIAL)
          ORDER BY NF.NRNOTAFISC

         OPEN C_TOMAD;
      FETCH NEXT FROM C_TOMAD INTO @C_DADOS, @C_NRLANCTONF, @C_CDFILIAL;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           (@V_CONTADOR, @C_DADOS , @P_NRSEQARQMAG);
         SET @V_CONTADOR = ISNULL(@V_CONTADOR,0)+1;

         UPDATE NOTAFISCAL
            SET IDEXPNFEDMSLON = 'S'
          WHERE CDFILIAL       = @C_CDFILIAL
            AND NRLANCTONF     = @C_NRLANCTONF;

         FETCH NEXT FROM C_TOMAD INTO @C_DADOS, @C_NRLANCTONF, @C_CDFILIAL;

      END;
      CLOSE C_TOMAD;
      DEALLOCATE C_TOMAD;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DMS_LONDRINA','5.45.000';
GO

